#include <bits/stdc++.h>

using namespace std;

const int Nmax=3*1e5;
const long long inf = LONG_MAX;

vector<pair<int,int>>edges[Nmax];
vector<int>vec;
int n;

void debug_edges()
{
    for (int i=1;i<=n;++i)
    {
        cout<<i<<": ";
        for (int j=0;j<edges[i].size();++j)
        {
            cout<<edges[i][j].first<<","<<edges[i][j].second<<" ";
        }
        cout<<'\n';
    }
}

bool used[Nmax];
long long dist[Nmax];

int djkstra (int st)
{
    fill(used,used+n+1,0);
    fill(dist,dist+n+1,inf);
    dist[st]=0;
    int v,u,len;
    for (int i=1;i<=n;++i)
    {
        v=-1;
        for (int j=1;j<=n;++j) if (!used[j]&&(v==-1||dist[j]<dist[v])) v=j;
        if (dist[v]==inf) break;
        used[v]=1;
        for (int j=0;j<edges[v].size();++j)
        {
            u=edges[v][j].first;
            len=edges[v][j].second;
            if (!used[u])
            {
                if (dist[v]+len<dist[u]) dist[u]=dist[v]+len;
            }
        }
    }
}

int main()
{
    cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(0);
    int a,b,c,g;
    long long res=0;
    cin>>n>>g;
    for (int i=0;i<n;++i)
    {
        cin>>a>>b>>c;
        edges[a].push_back(make_pair(b,c));
        if (g!=1) edges[b].push_back(make_pair(a,c));
    }
    if (g==1)
    {
        res=-1;
        long long sum=0;
        int v=1,u,len;
        fill(used,used+n+1,0);
        for (int i=1;i<=n;++i)
        {
            u=edges[v][0].first;
            len=edges[v][0].second;
            sum+=len;
            vec.push_back(len);
            v=u;
        }

        long long cur;
        for (int i=0;i<vec.size();++i)
        {
            cur=0;
            int j=i;
            while (cur<sum-cur)
            {
                cur+=vec[j];
                ++j;
                j%=vec.size();
            }
            res=max(res,min(cur,sum-cur));
        }
    }
    if (g==2)
    {
        res=-1;
        for (int i=1;i<=n;++i)
        {
            djkstra(i);
            for (int j=1;j<=n;++j)
            {
                res=max(res,dist[j]);
            }
        }
    }
    cout<<res<<'\n';
    return 0;
}
