#include <cstdio>
#include <vector>
#include <algorithm>
#include <utility>
#include <climits>

using namespace std;

typedef unsigned long long ull;

int n, g;
ull a, b, c;
ull suma = 0;
ull sumpr = 0;
ull sumcr;
vector<pair<int, int> > v[200000];
vector<ull> ld(10000), rd(10000);
vector<char> used(10000, 0);
vector<int> in_cir;

int wt = 0, wo;

int dfs_l(int cur, int dist)
{
    in_cir.push_back(cur);
    used[cur] = 1;
    ld[cur] = dist;
    for (pair<int, int> p : v[cur]) {
        int to = p.first;
        int len = p.second;
        if (!used[to]) {
            dfs_l(to, dist + len);
        }
    }
    return 0;
}

int dfs_r(int cur, int dist)
{
    used[cur] = 1;
    rd[cur] = dist;
    for (pair<int, int> p : v[cur]) {
        int to = p.first;
        int len = p.second;
        if (!used[to]) {
            dfs_r(to, dist + len);
        }
    }
    return 0;
}

ull dist(int i, int j) {
    return min(ld[i] + rd[j], sumcr - (ld[i] + rd[j]));
}


int calcdd()
{
    int cnt = 0;
    for (pair<int, int> p : v[wt]) {
        int to = p.first;
        int len = p.second;
        if (cnt ==  0) {
            in_cir.push_back(wt);
            ld[wt] = 0;
            used[wt] = 1;
            dfs_l(to, len);
        }
        if (cnt == 1) {
            fill(used.begin(), used.end(), 0);
            rd[wt] = 0;
            used[wt] = 1;
            dfs_r(to, len);
        }
    }
}

int get_min() {
    ull maxi = 0;
    for (int i : in_cir)
        for (int j : in_cir)
            maxi = max(maxi, dist(i, j));
    return maxi;
}

int main()
{
    scanf("%d%d", &n, &g);
    for (int i = 0; i < n; i++) {
        scanf("%llu%llu%llu", &a, &b, &c);
        a--;
        b--;
        v[a].push_back(make_pair(b, c));        
        v[b].push_back(make_pair(a, c));
        suma += c;
    }
    for (int i = 0; i < n; i++) {
        if (v[i].size() == 1) {
            wo = i;
        }
        if (v[i].size() == 3) {
            wt = i;
        }
    }
    int prev = -1;
    int cur = wo;
    int len;
    while (cur != wt) {
        for (pair<int, int> p : v[cur]) {
            int to = p.first;
            len = p.second;
            if (to != prev) {
                sumpr += len;
                prev = cur;
                cur = to;
                break;
            }
        }
    }
    v[cur].erase(remove(v[cur].begin(), v[cur].end(), make_pair(prev, len)), v[cur].end());
    sumcr = suma - sumpr;
    calcdd();
    printf("%llu\n", get_min());
    return 0;
}