from collections import defaultdict
import heapq as heap

n, g = [int(x) for x in input().split()]

graph = [dict() for _ in range(n)]

for _ in range(n):
  cross1, cross2, length = map(int, input().split())

  graph[cross1 - 1][cross2 - 1] = length
  graph[cross2 - 1][cross1 - 1] = length

def dijkstra(graph, startingNode):
	visited = set()
	pq = []
	nodeCosts = defaultdict(lambda: float('inf'))
	nodeCosts[startingNode] = 0
	heap.heappush(pq, (0, startingNode))
 
	while pq:
		_, node = heap.heappop(pq)
		visited.add(node)
 
		for adjNode, weight in graph[node].items():
			if adjNode in visited:	continue
				
			newCost = nodeCosts[node] + weight
			if nodeCosts[adjNode] > newCost:
				nodeCosts[adjNode] = newCost
				heap.heappush(pq, (newCost, adjNode))
        
	return nodeCosts

print(max([max(dijkstra(graph, i).values()) for i in range(n)]))