//#pragma GCC target("Ofast, unroll-loops")
//#pragma GCC optimize("avx, avx2, tune=native")

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <queue>
#include <assert.h>

using namespace std;

#define int long long
#define fi first
#define se second

vector<vector<pair<int, int>>> adj;
vector<int> used, cycle, ans, edges;
int sum = 0;

int find_dfs(int v, int p)
{
	used[v] = 1;
	for (int i = 0; i < adj[v].size(); ++i)
	{
		if (used[adj[v][i].fi])
		{
			if (adj[v][i].fi != p)
			{
				cycle.push_back(adj[v][i].fi);
				edges.push_back(adj[v][i].se);
				sum += adj[v][i].se;
				return 1;
			}
			continue;
		}
		if (find_dfs(adj[v][i].fi, v))
		{
			cycle.push_back(adj[v][i].fi);
			edges.push_back(adj[v][i].se);
			sum += adj[v][i].se;
			if (v == cycle[0]) return 0;
			return 1;
		}
	}
	return 0;
}

pair<int, int> dfs_dist(int v, int p)
{
	pair<int, int> cur = { 0, v }, c;
	for (int i = 0; i < adj[v].size(); ++i)
	{
		if (adj[v][i].fi == p || used[adj[v][i].fi]) continue;
		c = dfs_dist(adj[v][i].first, v);
		if (c.first + adj[v][i].se > cur.fi)
		{
			cur = c;
			cur.first += adj[v][i].se;
		}
	}
	return cur;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, useless, c1, c2, c3, res = 0;
	cin >> n >> useless;
	adj.resize(n);
	used.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> c1 >> c2 >> c3;
		--c1;
		--c2;
		adj[c1].push_back({ c2, c3 });
		adj[c2].push_back({ c1, c3 });
	}
	find_dfs(0, 0);
	used = vector<int>(n);
	for (int i = 0; i < cycle.size(); ++i) used[cycle[i]] = 1;
	ans.resize(cycle.size());
	for (int i = 0; i < cycle.size(); ++i)
	{
		for (int j = 0; j < adj[cycle[i]].size(); ++j)
		{
			pair<int, int> x = dfs_dist(cycle[i], cycle[i]);
			ans[i] = x.first;
			res = max(res, dfs_dist(x.second, x.se).fi);
		}
	}
	int r = 0;
	int m = cycle.size();
	int csum = 0;
	vector<int> nans(ans.size());
	for (int i = 0; i < m; ++i)
	{
		//cout << cycle[i] << " " << ans[i] << '\n';
		if (csum < 0)
		{
			csum = 0;
			r = i;
		}
		if (i > 0) nans[i] = max(0ll, nans[i - 1] - edges[i - 1] - ans[i - 1] + ans[i]);
		while (csum + edges[r] <= sum / 2)
		{
			csum += edges[r];
			r++;
			if (r >= m) r -= m;
			nans[i] = max(nans[i], min(csum, sum - csum) + ans[r] + ans[i]);
			//cout << cycle[i] << " " << ans[i] << " * " << cycle[r] << " " << ans[r] << '\n';
		}
		csum -= edges[i];
	}

	for (int i = 0; i < ans.size(); ++i) res = max(res, nans[i]);
	cout << res << '\n';

	return 0;
}

/*
6
0
1 2 100
2 3 100
2 4 100
4 5 1
5 6 1
4 6 1

9 0
1 2 1
2 7 2
7 9 3
2 6 4
6 5 5
5 8 6
8 7 7
5 4 8
4 3 9

5 0
1 2 100
2 3 1
3 4 1
4 2 100
3 5 100
*/