//#pragma GCC target("Ofast, unroll-loops")
//#pragma GCC optimize("avx, avx2, tune=native")

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <queue>
#include <cassert>
#include <bitset>

using namespace std;

//#define int long long
#define fi first
#define se second

const int l = 21;

vector<vector<int>> adj;
vector<vector<int>> basis;
vector<int> sz;
vector<int> a;

void add_basis(int num, int x)
{
	for (int i = l - 1; i >= 0; --i)
	{
		if (x & (1 << i))
		{
			if (basis[num][i] == 0)
			{
				basis[num][i] = x;
				++sz[num];
				return;
			}
			x ^= basis[num][i];
		}
	}
}

void dfs(int v, int p)
{
	add_basis(v, a[v]);
	for (int i = 0; i < adj[v].size(); ++i)
	{
		if (adj[v][i] == p) continue;
		dfs(adj[v][i], v);
		for (int j = 0; j < l; ++j) if (basis[adj[v][i]][j]) add_basis(v, basis[adj[v][i]][j]);
	}
}

int kth(int num, int k)
{
	if (k > (1 << sz[num])) return -1;
	int ans = 0, cur = sz[num];
	for (int i = l - 1; i >= 0; --i)
	{
		if (basis[num][i])
		{
			--cur;
			if (k > (1 << cur))
			{
				k -= (1 << cur);
				if (!(ans & (1 << i))) ans ^= basis[num][i];
			}
			else if (ans & (1 << i)) ans ^= basis[num][i];
		}
	}
	return ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, g, c1, c2, type;
	cin >> n >> g;
	adj.resize(n);
	a.resize(n);
	basis.resize(n, vector<int>(l));
	sz.resize(n);
	for (int i = 0; i < (n - 1); ++i)
	{
		cin >> c1 >> c2;
		--c1;
		--c2;
		adj[c1].push_back(c2);
		adj[c2].push_back(c1);
	}
	for (auto& i : a) cin >> i;
	dfs(0, 0);
	/*for (int i = 0; i < n; ++i)
	{
		for(int j = 0; j < l; ++j) cout << basis[i][j] << " ";
		cout << '\n';
	}*/
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i)
	{
		cin >> type >> c1 >> c2;
		if (type == 1)
		{
			--c1;
			a[c1] = c2;
			basis = vector<vector<int>>(n, vector<int>(l));
			sz = vector<int>(n);
			dfs(0, 0);
		}
		else
		{
			--c1;
			cout << kth(c1, c2) << '\n';
		}
	}

	return 0;
}

/*
3
0
1 2
2 3
10 5 6
100
*/