#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <functional>
#include <string.h>
#include <queue>
#include <stdio.h>
#include <stack>


using namespace std;

#define int long long

vector<vector<pair<int,int> > > g;
vector<int> c;
vector<int> p;

int c_s, c_e;

bool find_cycle(int v,int pred = -1){
    c[v] = 1;
    for(auto it: g[v]){
        if(!c[it.first]){
            p[it.first] = v;
            if(find_cycle(it.first, v)) return 1;
        }
        else if(c[it.first] == 1 && it.first != pred){
            c_s = it.first;
            c_e = v;
            return 1;
        }
    }
    c[v] = 2;
    return 0;
}

signed main(){
    int n,a;
    cin >> n >> a;
    c.resize(n);
    p.resize(n);
    g.resize(n);
    for(int i = 0;i<n;i++){
        int x,y,z;
        cin >> x >> y >> z;
        --x;
        --y;
        g[x].push_back({y,z});
        g[y].push_back({x,z});
    }
    find_cycle(0);
    vector<int> cc;
    cc.push_back(c_s);
    for(int i = c_e; i != c_s;i = p[i]){
        cc.push_back(i);
    }
    reverse(cc.begin(),cc.end());
    sort(cc.begin(),cc.end());
    vector<bool> in_c(n);
    for(auto it : cc) in_c[it] = 1;
    
    map<pair<int,int>,int > m;
    
    for(int i = 0;i<n;i++){
        if(!in_c[i]) continue;
        queue<int> q;
        q.push(i);
        vector<int> dist(n,1e16);
        dist[i] = 0;
        while(q.size()){
            int x = q.front();
            q.pop();
            for(auto it: g[x]){
                if(!in_c[it.first]) continue;
                if(dist[it.first] == 1e16 || dist[it.first] > (it.second+dist[x])){
                    dist[it.first] = dist[x]+it.second;
                    q.push(it.first);
                }
            }
        }
        for(int z =0;z<n;z++){
            if(!in_c[z]) continue;
            m[{i,z}] = m[{z,i}] = dist[z];
        }
        dist.clear();
    }
    int res = 0;
    vector<int> ans(n);
    for(auto v: cc){
        vector<int> dist(n, 1e16);
        dist[v] = 0;
        stack<int> st;
        st.push(v);
        while(st.size()){
            int x = st.top();
            st.pop();
            for(auto it: g[x]){
                if((dist[it.first] == 1e16 || dist[it.first] > (dist[x]+it.second) )&& !in_c[it.first]){
                    dist[it.first] = dist[x]+it.second;
                    st.push(it.first);
                }
            }
        }
        int aa;
        aa = -1;
        for(int i = 0;i<n;i++){
            if(dist[i] == 1e16) continue;
            if(aa == -1 || dist[aa] < dist[i]){
                aa = i;
            }
        }
        int vv = aa;
        if(aa == -1) aa = 0;
        else aa = dist[aa];
        
        if(vv == -1) continue;
        
        ans[v] = aa;
        dist.clear();
        
        dist = vector<int>(n,1e16);
        dist[vv] = 0;
        st.push(vv);
        while(st.size()){
            int x = st.top();
            st.pop();
            for(auto it: g[x]){
                if(in_c[it.first]) continue;
                if(dist[it.first] == 1e16 || dist[it.first] > (dist[x]+it.second)){
                    dist[it.first] = dist[x]+it.second;
                    st.push(it.first);
                }
            }
        }
        for(auto it:dist){
            if(it != 1e16) res = max(res,it);
        }
    }
    for(int i = 0;i<cc.size();i++){
        for(int z = i+1;z<cc.size();z++){
            res = max(res,ans[cc[i]]+ans[cc[z]]+m[{cc[i],cc[z]}]);
        }
    }
    cout << res << endl;
    
}

/*
 7 0
 1 2 1
 2 3 1
 3 4 1
 1 4 1
 4 5 1
 5 6 100
 5 7 100
 */
