#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
using namespace std;

int n, g, a[200'000], b[200'000], c[200'000];

vector<ll> dist;
vector<int> color(200'001);
set<int> in_cycle, in_tree;

void Dijkstra(vector<vector<pair<int, int> > > &graph, int v)
{
    dist.assign(n+1, LLONG_MAX);

    priority_queue<pair<ll, int>, vector<pair<ll, int> >, greater<pair<ll, int> > > pq;
    pq.push({0, v});
    dist[v]=0;

    while(!pq.empty()){
        v=pq.top().se;
        pq.pop();
        for(auto p: graph[v]){
            int u=p.fi, w=p.se;
            if(dist[v]+w < dist[u]){
                dist[u]=dist[v]+w;
                pq.push({dist[u], u});
            }
        }
    }
}

void find_cycle(vector<vector<pair<int, int> > > &graph, int v)
{
    if(color[v]==1){
        for(int i=1; i<=n; i++){
            if(color[i]==1){
                in_cycle.insert(i);
            }
        }
        return;
    }

    color[v]=1;
    for(auto x: graph[v]){
        int u=x.fi;
        if(color[u]!=2){
            find_cycle(graph, u);
        }
    }

    color[v]=2;
}

ll find_tree(vector<vector<pair<int, int> > > &graph, int v, int p)
{
    in_tree.insert(v);
    for(auto x: graph[v]){
        int u=x.fi;
        if(!in_cycle.count(u) && u!=p){
            find_tree(graph, u, v);
        }
    }
}

ll find_diameter(vector<vector<pair<int, int> > > &graph, int st)
{
    Dijkstra(graph, st);
    int mx_v=st;
    for(int i=1; i<=n; i++){
        if(dist[i]>dist[mx_v]){
            mx_v=i;
        }
    }
    Dijkstra(graph, mx_v);
    for(int i=1; i<=n; i++){
        if(dist[i]>dist[mx_v]){
            mx_v=i;
        }
    }
    return dist[mx_v];
}


ll max_path(vector<vector<pair<int, int> > > &graph, int v, int p)
{
    ll res=0;
    for(auto x: graph[v]){
        int u=x.fi, w=x.se;
        if(u!=p){
            res=max(res, max_path(graph, u, v))+w;
        }
    }
    return res;
}

vector<vector<pair<int, int> > > construct_graph(set<int> &st)
{
    vector<vector<pair<int, int> > > graph(n+1);
    for(int i=1; i<=n; i++){
        if(st.count(a[i]) && st.count(b[i])){
            graph[a[i]].push_back({b[i], c[i]});
            graph[b[i]].push_back({a[i], c[i]});
        }
    }
    return graph;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> g;
    vector<vector<pair<int, int> > > graph(n+1);
    for(int i=0; i<n; i++){
        cin >> a[i] >> b[i] >> c[i];
        graph[a[i]].push_back({b[i], c[i]});
        graph[b[i]].push_back({a[i], c[i]});
    }

    if(g==0 || g==2){
        ll mx=0;
        for(int i=1; i<=n; i++){
            Dijkstra(graph, i);
            for(int j=1; j<=n; j++){
                mx=max(mx, dist[j]);
            }
        }
        cout << mx;
        return 0;
    }

    if(g==3){
        ll mx=0;
        map<int, ll> to_leaf;

        find_cycle(graph, 1);

        for(auto v: in_cycle){
            in_tree.clear();
            find_tree(graph, v, 0);
            vector<vector<pair<int, int> > > tree=construct_graph(in_tree);
            to_leaf[v]=max_path(tree, v, 0);
            ll diameter=find_diameter(tree, v);
            mx=max(mx, diameter);
        }
        vector<int> cycle(in_cycle.begin(), in_cycle.end());
        vector<vector<pair<int, int> > > ic=construct_graph(in_cycle);
        for(int i=0; i<cycle.size(); i++){
            for(int j=i+1; j<cycle.size(); j++){
                int v=cycle[i], u=cycle[j];
                Dijkstra(ic, v);
                mx=max(mx, to_leaf[v]+to_leaf[u]+dist[u]);
            }
        }
        cout << mx;
    }

    cout << find_diameter(graph, 1);

    return 0;
}