#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <climits>

using namespace std;



class Node;
vector<Node*> nodes;

bool NextSet(int *a, int n, int m)
{
	int k = m;
	for (int i = k - 1; i >= 0; --i)
		if (a[i] < n - k + i + 1)
		{
			++a[i];
			for (int j = i + 1; j < k; ++j)
				a[j] = a[j - 1] + 1;
			return true;
		}
	return false;
}

template <typename T>
bool contains(vector<T> vec, const T & elem)
{
	bool result = false;
	if (find(vec.begin(), vec.end(), elem) != vec.end())
	{
		result = true;
	}
	return result;
}

class Conn {
public:
	Conn(Node* start, Node* end, int w) : start(start), end(end), weight(w) {}

	Node* start;
	Node* end;
	int weight;
};

class Node {
public:
	vector<Conn*> connect;
};

class Path {
public:
	vector<Conn*> path;
	vector<Node*> past;
	int weight() {
		int w = 0;
		for (size_t i = 0; i < path.size(); i++) {
			w += path[i]->weight;
		}
		return w;
	}
};

int findPath(Node* a, Node* b) {
	vector<Path*> pathes;

	for (size_t i = 0; i < a->connect.size(); i++) {
		Path* p = new Path();
		p->path.push_back(a->connect[i]);
		p->past.push_back(a);
		pathes.push_back(p);
	}

	int edits = 0;
	while (edits != 0) {
		vector<Path*> tmp;
		for (int i = 0; i < pathes.size(); i++) {
			if (pathes[i]->path.back()->end != b && pathes[i]->path.back()->end->connect.size() > 1) {
				Path* p = new Path(*pathes[i]);
				for (int j = 0; j < p->path.back()->end->connect.size(); j++) {
					Path* pp = new Path(*p);
					Conn* c = p->path.back()->end->connect[i];
					if (!contains(pp->past, c->end)) {
						pp->path.push_back(c);
						pp->past.push_back(c->end);
					}
					tmp.push_back(pp);
					edits++;
				}
				pathes.erase(pathes.begin() + i);
				i--;
			}
		}
		if (edits != 0) {
			pathes.insert(pathes.end(), tmp.begin(), tmp.end());
		}
	}

	int min = INT_MAX;
	for (int i = 0; i < pathes.size(); i++) {
		if (pathes[i]->path.back()->end == b) {
			int w = pathes[i]->weight();
			if (w < min) {
				min = w;
			}
		}
	}
	return min;
	

}

void addToVec(vector<pair<int, int>>* v, int a, int b) {
	v->push_back(make_pair(a, b));
}

int main() {
	int n, g;
	cin >> n >> g;

	vector<int> a(n), b(n), c(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i] >> c[i];
	}

	for (int i = 0; i < n+1; i++) {
		nodes.push_back(new Node);
	}

	for (int i = 0; i < n; i++) {
		int ai = a[i];
		int bi = b[i];
		Node* an = nodes[ai];
		Node* bn = nodes[bi];
		int cw = c[i];

		Conn* con = new Conn(an, bn, cw);
		an->connect.push_back(con);
		bn->connect.push_back(con);
	}
	
	vector<pair<int, int>>* pairs = new vector<pair<int, int>>();
	int *set = new int[n];
	for (int i = 0; i < n; i++)
		set[i] = i + 1;
	addToVec(pairs, set[0], set[1]);
	while (NextSet(set, n, 2))
		addToVec(pairs, set[0], set[1]);

	int max = INT_MIN;
	for (int i = 0; i < pairs->size(); i++) {
		int ans = findPath(nodes[pairs->at(i).first], nodes[pairs->at(i).second]);
		if (ans > max)
			max = ans;
	}

	cout << max << endl;
}