#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>
#include <sstream>
#include <set>

using namespace std;

vector<vector<int>> ways;
vector<pair<int, set<int>>> nums;

set<int> PrintAllSubsets(set<int> arr, int n) {
	set<int> res;
	int snum = 0;
	while (snum < pow(2, n)) {
		int tt = 0;
		for (int i = 0; i < n; ++i) {
			// the following condition checks
			// if the ith bit of snum in binary form
			// is 1 or not
			if ((snum & (1 << i)) != 0) {
				tt = tt ^ *std::next(arr.begin(), i);
			}
		}
		res.insert(tt);
		++snum;
	}
	return res;
}

set<int> Remake(int sp, int cf)
{
	set<int> res;
	res.insert(nums[sp].first);
	for (int i = 0; i < ways[sp].size(); i++)
	{
		if (ways[sp][i] != cf)
		{
			set<int> tset = Remake(ways[sp][i], sp);
			res.insert(tset.begin(), tset.end());
		}
	}
	nums[sp].second = res;
	return res;
}



int main()
{
	string s;
	bool b = false;
	vector<int> res;
	int ginps=0;
	int n, g;
			cin >> n >> g;
			ways = vector<vector<int>>(n);
			vector<bool> v = vector<bool>(n);
			for (int i = 0; i < n-1; i++)
			{
				int xi, yi;
				cin >> xi >> yi;
				xi--;
				yi--;
				v[yi] = true;
				ways[xi].push_back(yi);
			}
			int kor;
			for (kor = 0; kor < v.size(); kor++)
			{
				if (v[kor] == false) break;
			}
			for (int i = 0; i < n; i++)
			{
				int inp;
				cin >> inp;
				nums.push_back(pair<int, set<int>>(inp, set<int>()));
			}
			
			Remake(kor, -1);

			int q;
			cin >> q;
			for (int i = 0; i < q; i++)
			{
				int vi, ki, t;
				cin >> t >> vi >> ki;
				vi--;
				if (t == 1)
				{
					nums[vi].first = ki;
					Remake(kor, -1);
				}
				if (t == 2)
				{
					set<int> tls = PrintAllSubsets(nums[vi].second, nums[vi].second.size());
					if (tls.size() < ki) cout << "-1";
					else cout<<*std::next(tls.begin(), ki-1);
					cout << "\n";
				}
			}
}