#include<bits/stdc++.h>
using namespace std;

const int NMAX=2e5;
vector<pair<int,int>>g[NMAX+5];

bool used[NMAX+5];
void clear_used(int n){
    for(int i=1;i<=n;i++)used[i]=0;
}

vector<int>current_nodes;
vector<int>cycle;
bool is_cycle[NMAX+5];
void find_cycle(int v,int p=-1){
    used[v]=1;
    current_nodes.push_back(v);

    for(auto [u,c]:g[v]){
        if(!used[u])find_cycle(u,v);
        else if(used[u]&&u!=p&&cycle.empty()){
            for(auto e:current_nodes)cycle.push_back(e);
            reverse(cycle.begin(),cycle.end());
            while(!cycle.empty()&&cycle.back()!=u)cycle.pop_back();
            reverse(cycle.begin(),cycle.end());
        }
    }

    current_nodes.pop_back();
}

bool can_use[NMAX+5];
int depth[NMAX+5];
void calc_depth(int v,int p=-1){
    depth[v]=1;
    for(auto [u,c]:g[v]){
        if(u!=p&&can_use[u]&&!is_cycle[u])calc_depth(u,v),depth[v]+=depth[u];
    }
}

void set_cant_use(int v,vector<int>&vec,int p=-1){
    can_use[v]=0;
    vec.push_back(v);
    for(auto [u,c]:g[v]){
        if(u!=p&&!is_cycle[u]&&can_use[u])set_cant_use(u,vec,v);
    }
}
long long get_root_dist(int v,int p=-1){
    long long ans=0;
    for(auto [u,c]:g[v]){
        if(u!=p&&can_use[u]&&!is_cycle[u])ans=max(ans,c+get_root_dist(u,v));
    }
    return ans;
}

//   max dist  root dist
pair<long long,long long>centroid_decomposition(int v,int p=-1){
    //cout<<"tree with root "<<v<<"\n";
    int root=v;
    int root_depth=0;
    calc_depth(v,-1);
    // searching center
    while(true){
        if(root_depth>=depth[v])break;

        int total_depth=depth[v];
        int biggest_child=-1;

        for(auto [u,c]:g[v]){
            if(u==p||is_cycle[u]||!can_use[u])continue;
            if(biggest_child==-1||depth[u]>=depth[biggest_child])biggest_child=u;
        }
        p=v;
        v=biggest_child;
        root_depth+=total_depth-depth[v];  
    }
    //cout<<"root="<<root<<" center: "<<v<<"\n";
    //for(int i=1;i<=10;i++)if(can_use[i]&&!is_cycle[i])cout<<i<<" ";cout<<"\n";
    if(v==-1)return{0,0};

    vector<int>cur_cant_use;

    // p->v
    set_cant_use(p,cur_cant_use,v);
    auto [x,y]=centroid_decomposition(v,p);
    for(auto e:cur_cant_use)can_use[e]=1;
    cur_cant_use.clear();

    // v->p
    set_cant_use(v,cur_cant_use,p);
    auto [X,Y]=centroid_decomposition(p,v);
    for(auto e:cur_cant_use)can_use[e]=1;
    cur_cant_use.clear();

    int edge_cost=0;
    for(auto [u,c]:g[v]){
        if(u==p)edge_cost=c;
    }
    long long max_dist=max({x,X,y+Y+edge_cost});
    long long root_dist=get_root_dist(root,-1);
    //cout<<"x="<<x<<" X="<<X<<" y="<<y<<" Y="<<Y<<"\n";
    //cout<<"ans for root="<<root<<" v="<<v<<" p="<<p<<" "<<max_dist<<" "<<root_dist<<"\n";
    return {max_dist,root_dist};
}

long long cost[NMAX+5];

int get_edge(int v,int u){
    if(u==-1)return 0;
    for(auto [uu,c]:g[v])if(uu==u)return c;
}

long long dp[NMAX+5];
long long naive_solution(int n){
    long long ans=0;
    for(int i=1;i<=n;i++){
        for(int i=1;i<=n;i++)dp[i]=1e18,used[i]=0;
        priority_queue<pair<long long,int>>q;
        q.push({0,i});
        while(!q.empty()){
            auto [c,v]=q.top();
            c=-c;
            q.pop();
            if(used[v])continue;
            used[v]=1;
            for(auto [u,cc]:g[v]){
                long long newcc=c+cc;
                if(newcc<dp[u]){
                    dp[u]=newcc;
                    q.push({-newcc,u});
                }
            }
        }
        ans=max(ans,*max_element(dp+1,dp+1+n));
    }
    return ans;
}

signed main(){
    srand(time(0));
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n,gg;
    cin>>n>>gg;
    for(int i=1;i<=n;i++){
        int u,v,c;
        cin>>u>>v>>c;
        //c=rand()%5+1;
        g[u].push_back({v,c});
        g[v].push_back({u,c});
        //cout<<u<<" "<<v<<" "<<c<<"\n";
    }
    
    //cout<<ans<<"\n";
    if(gg==2)
        cout<<naive_solution(n)<<"\n";
    else if(gg==1||gg==2||gg==4){
    // searcing cycle

    find_cycle(1,-1);

    for(auto e:cycle)is_cycle[e]=1;

    clear_used(n);



    //cout<<"found cycle:\n";

    //for(auto e:cycle)cout<<e<<" ";cout<<"\n";



    long long ans=0;



    // centroid decomposition

    for(int i=1;i<=n;i++)can_use[i]=1;

    for(auto e:cycle){

        //cout<<"ROOT "<<e<<"\n";

        is_cycle[e]=0;

        auto [max_dist,root_dist]=centroid_decomposition(e,-1);

        is_cycle[e]=1;

        cost[e]=root_dist;

        ans=max(ans,max_dist);

    }

    long long D=0;

    for(int i=0;i<cycle.size();i++){

        D+=get_edge(cycle[i],cycle[(i+(int)cycle.size()-1)%((int)cycle.size())]);

    }

    //cout<<"D = "<<D<<"\n";



    long long dist=0;

    priority_queue<pair<long long,long long>>q;

    q.push({0,0});

    for(int iii=0;iii<1;iii++){
        int cnt=0;
    for(int i=iii;;i++){

        int ii=i;

        i%=cycle.size();

        //cout<<"cost for "<<cycle[i]<<" = "<<cost[cycle[i]]<<"\n";

        //cout<<"edge "<<cycle[i]<<" "<<cycle[(i-1+(int)cycle.size())%((int)cycle.size())]<<"\n";

        long long d=dist+((ii==0)?0:get_edge(cycle[i],cycle[(i-1+(int)cycle.size())%((int)cycle.size())]));

        //cout<<"d = "<<d<<"\n";

        while(!q.empty()&&(d-q.top().second)*2>D)q.pop();
        if(!q.empty()){
        long long val=d+cost[cycle[i]];

        ans=max(ans,val+q.top().first);}

        q.push({-d+cost[cycle[i]],d});

        dist=d;
        cnt++;
        if(cnt>1050)break;
    }
    }
    cout<<ans<<"\n";

    }
}