#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> dijkctra(int n, int start, vector<vector<int>> graph){
    vector<int> D(n);
    vector<int> Unopened(n);
    for(int i = 0; i < n; ++i){
        D[i] = min(graph[start][i], graph[i][start]);
        Unopened[i] = i;
    }
    Unopened.erase(find(Unopened.begin(), Unopened.end(), start));

   while(Unopened.size() > 0){
        int w = Unopened[0];
        for(int j: Unopened){
            if(D[w] > D[j]){
                w = j;
            }
        }

        Unopened.erase(find(Unopened.begin(), Unopened.end(), w));

        for(int j: Unopened){
            D[j] = min(D[j], D[w]+ graph[w][j]);
        }
    }

    return D;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, g;
    cin >> n >> g;

    vector<int> starts(n), ends(n), values(n);
    for (int i = 0; i < n; i++) {
        cin >> starts[i] >> ends[i] >> values[i];
    }

    vector<vector<int>> graph(n, vector<int>(n, 1E9 + 1));

    for(int i = 0; i < n; ++i) {
        graph[starts[i] - 1][ends[i] - 1] = values[i];
    }
    int max = 0;
    for(int i = 0; i < n; ++i){
        auto s = dijkctra(n, i, graph);
        for(auto item : s){
            if(item != 1E9 + 1 && item > max) max = item;
        }
    }
    cout << max;
}

