#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int miniDist(const vector<int> &distance, const vector<bool> &Tset, const int &n) // finding minimum distance
{
    int minimum = 1E9+1, ind = 0;

    for (int k = 0; k < n; k++) {
        if (Tset[k] == false && distance[k] <= minimum) {
            minimum = distance[k];
            ind = k;
        }
    }
    return ind;
}

vector<int> dijkctra(const int &n, const int &start, const vector<vector<int>> &graph) {
    vector<int> distance(n);
    vector<bool> Tset(n);
    for (int i = 0; i < n; ++i) {
        distance[i] = 1E9+1;
        Tset[i] = false;
    }

    distance[start] = 0;

    for (int k = 0; k < n; k++) {
        int m = miniDist(distance, Tset, n);
        Tset[m] = true;

        for (int i = 0; i < n; i++) {
            if (!Tset[i] && min(graph[m][i], graph[i][m]) && distance[m] != 1E9+1 && distance[m] + min(graph[m][i], graph[i][m]) < distance[i])
                distance[i] = distance[m] + min(graph[m][i], graph[i][m]);
        }
    }

    return distance;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, g;
    cin >> n >> g;

    vector<int> starts(n), ends(n), values(n);
    for (int i = 0; i < n; i++) {
        cin >> starts[i] >> ends[i] >> values[i];
    }

    vector<vector<int>> graph(n, vector<int>(n, 1E9 + 1));

    for (int i = 0; i < n; ++i) {
        graph[starts[i] - 1][ends[i] - 1] = values[i];
    }
    int max = 0;
    for (int i = 0; i < n - 1; ++i) {
        auto s = dijkctra(n, i, graph);
        for (auto item: s) {
            if ((item != (1E9 + 1)) && (item > max)) max = item;
        }
    }
    cout << max << endl;
    return 0;
}
