#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> dijkctra(const int &n, const int &start, const vector<vector<int>> &graph){
    vector<int> D(n);
    vector<int> Unopened(n);
    for(int i = 0; i < n; ++i){
        D[i] = min(graph[start][i], graph[i][start]);
        Unopened[i] = i;
    }
    Unopened.erase(find(Unopened.begin(), Unopened.end(), start));
    D[start] = 0;

    while(Unopened.size() > 0){
        int w = Unopened[0];
        for(int j: Unopened){
            if(D[w] > D[j]){
                w = j;
            }
        }

        Unopened.erase(find(Unopened.begin(), Unopened.end(), w));

        for(int j: Unopened){
            D[j] = min(D[j], D[w]+ min(graph[w][j], graph[j][w]));
        }
    }

    return D;
}

int main() {
    int n, g;
    cin >> n >> g;

    vector<vector<int>> graph(n, vector<int>(n, 1E9 + 1));
    int start, end, value;
    for (int i = 0; i < n; ++i) {

        cin >> start >> end >> value;
        graph[start - 1][end - 1] = value;
    }
    int max = 0;
    for (int i = 0; i < n - 1; ++i) {
        auto s = dijkctra(n, i, graph);
        for (auto item: s) {
            if ((item != (1E9 + 1)) && (item > max)) max = item;
        }
    }
    cout << max << endl;
    return 0;
}
