#include <iostream>
#include <vector>
#include <queue>

using namespace::std;


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    int n, g;
    cin >> n >> g;

    vector<vector<pair<int, int>>> adj(n + 1);

    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        adj[a].push_back({ b, c });
    }

    const int INF = 2147483647;

    int answer = 0;

    for (int x = 1; x <= n; x++) {

        priority_queue<pair<int,int>> q;

        vector<bool> processed(n + 1);
        vector<bool> distance(n + 1);

        for (int i = 1; i <= n; i++) {
            distance[i] = INF;
        }

        distance[x] = 0;
        q.push({0,x});
        while (!q.empty()) {
                int a = q.top().second; q.pop();
                if (processed[a]) continue;

                processed[a] = true;
		    for (auto u : adj[a]) {
                int b = u.first, w = u.second;
                if (distance[a]+w < distance[b]) {
                        distance[b] = distance[a]+w;

                        answer = max(answer, distance[a]+w);

                        q.push({-distance[b],b});
                }
		    }
        }
    }

    cout << answer;

    return 0;    
}