#include <iostream>
#include <vector>
#include <queue>

using namespace::std;


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    
    int n, g;
    cin >> n >> g;

    vector<vector<pair<int, int>>> adj(n + 1);

    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        adj[a].push_back({ b, c });
        adj[b].push_back({ a, c });
    }

    int answer = 0;

    for (int r = 1; r <= n; r++) {
        queue<int> q;
        vector<bool> visited(n + 1);
        vector<int> distances(n + 1);

        visited[r] = true;
        distances[r] = 0;

        q.push(r);

        while(!q.empty()) {
            int s = q.front(); q.pop();

            for (auto u : adj[s]) {
                if (visited[u.first]) continue;
                
                visited[u.first];
                distances[u.first] = distances[s] + u.second;
                q.push(u.first);

                answer = max(answer, distances[s] + u.second);
            }
        }
    }

    cout << answer << "\n";

    return 0;    
}