#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

constexpr ll INF = 1000000000;

ll n, g, m, w, t;
map<ll, ll> G[200000];

vector<ll> find_cycle();
ll find_tree_diameter(ll fx, ll fy);

int main() {
    cin >> n >> g;
    vector<ll> a(n), b(n), c(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> c[i];
        a[i]--;
        b[i]--;
//        G[a[i]].push_back({b[i], c[i]});
//        G[b[i]].push_back({a[i], c[i]});
        G[a[i]][b[i]] = c[i];
        G[b[i]][a[i]] = c[i];
    }
    vector<ll> cycle = find_cycle();
//    for (int i : cycle) {
//        cout << i << '\n';
//    }
    ll sum = 0;
    vector<ll> pr(n);
    for (int i = 0; i < cycle.size(); i++) {
        sum += G[cycle[i]][cycle[(i + 1) % cycle.size()]];
        pr[i] = sum;
    }
//    cout << sum << '\n';
    ll ans = 1000000;
    ans = min(ans, find_tree_diameter(cycle[0], cycle[1]));
//    cout << 0 << '\n';
    ll prev = 0;
    for (int i = 1; i < cycle.size(); i++) {
//        cout << pr[i] << ' ' << pr[prev] << ' ' << sum / 3 << '\n';
        if (pr[i] - pr[prev] >= sum / 3) {
            ans = min(ans, find_tree_diameter(cycle[i], cycle[(i + 1) % cycle.size()]));
//            cout << i << '\n';
            prev = i;
        }
    }
    cout << ans << '\n';
}

vector<ll> find_cycle() {
    vector<ll> ans;
    ll b = 0;
    stack<ll> st;
    vector<bool> used(n);
    vector<ll> par(n);
    st.push(b);
    par[b] = -1;
    while (!st.empty()) {
        ll x = st.top();
        st.pop();
        if (used[x]) {
            continue;
        }
        used[x] = 1;
        for (auto i : G[x]) {
//            cout << x << ' ' << i.first << '\n';
            if (!used[i.first]) {
                par[i.first] = x;
                st.push(i.first);
            }
            else if (i.first != par[x]) {
                par[i.first] = x;
                ans.push_back(i.first);
                ll y = i.first;
                while (par[y] != i.first) {
//                    cout << '\t' << y << ' ' << par[y] << '\n';
                    ans.push_back(par[y]);
                    y = par[y];
                }
                return ans;
            }
        }
    }
}

ll find_tree_diameter(ll fx, ll fy) {
//    cout << fx << ' ' << fy << '\n';
    ll d = 0;
    vector<ll> dist0(n, INF);
    vector<bool> used0(n);
    dist0[d] = 0;
    priority_queue< pair<ll, ll> > pq;
    pq.push({0, d});
    while (!pq.empty()) {
        auto p = pq.top();
        pq.pop();
        ll x = p.second;
        if (used0[x]) {
            continue;
        }
        used0[x] = 1;
        for (auto i : G[x]) {
            if (x == fx && i.first == fy || x == fy && i.first == fx) {
                continue;
            }
            if (!used0[i.first]) {
                dist0[i.first] = min(dist0[i.first], dist0[x] + i.second);
                pq.push({-dist0[x] - i.second, i.first});
            }
        }
    }
    ll f = 0;
    for (int i = 1; i < n; i++) {
        if (dist0[i] >= dist0[f]) {
            f = i;
        }
    }
    vector<ll> distf(n, INF);
    vector<bool> usedf(n);
    distf[f] = 0;
    pq.push({0, f});
    while (!pq.empty()) {
        auto p = pq.top();
        pq.pop();
        ll x = p.second;
        if (usedf[x]) {
            continue;
        }
        usedf[x] = 1;
        for (auto i : G[x]) {
            if (x == fx && i.first == fy || x == fy && i.first == fx) {
                continue;
            }
            if (!usedf[i.first]) {
                distf[i.first] = min(distf[i.first], distf[x] + i.second);
                pq.push({-distf[x] - i.second, i.first});
            }
        }
    }
    ll e = 0;
    for (int i = 1; i < n; i++) {
        if (distf[i] >= distf[e]) {
            e = i;
        }
    }
//    for (int i : dist0) {
//        cout << i << ' ';
//    }
//    cout << '\n';
//    for (int i : distf) {
//        cout << i << ' ';
//    }
//    cout << '\n';
    return distf[e];
}
