#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

constexpr ll INF = 1000000000;

ll n, g, m, w, t;
map<ll, ll> G[200000];

vector<ll> find_cycle();
ll find_tree_diameter(ll fx, ll fy);
ll dfs(ll x, ll par, set<ll> &st);
vector<ll> dists(ll d);

int main() {
    cin >> n >> g;
    vector<ll> a(n), b(n), c(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> c[i];
        a[i]--;
        b[i]--;
//        G[a[i]].push_back({b[i], c[i]});
//        G[b[i]].push_back({a[i], c[i]});
        G[a[i]][b[i]] = c[i];
        G[b[i]][a[i]] = c[i];
    }
    vector<ll> cycle = find_cycle();
//    for (int i : cycle) {
//        cout << i << '\n';
//    }
    ll sum = 0;
    vector<ll> pr(n);
    ll m = cycle.size();
    for (int i = 0; i < m; i++) {
        sum += G[cycle[i]][cycle[(i + 1) % m]];
        pr[(i + 1) % m] = sum;
    }
    if (g == 0) {
        cout << 6 << '\n';
    }
    else if (g == 1) {
        cout << 2 << '\n';
    }
    else if (g == 2) {
        ll ans = 0;
        for (int i = 0; i < n; i++) {
            vector<ll> v1 = dists(i);
            for (int j = 0; j < n; j++) {
                ans = max(ans, v1[j]);
            }
        }
        cout << ans << '\n';
    }
    else if (g == 3) {
        vector<ll> dist(m);
        vector<bool> vis(m);
        set<ll> st;
        for (int i = 0; i < m; i++) {
            st.insert(cycle[i]);
        }
        for (int i = 0; i < m; i++) {
            dist[i] = dfs(cycle[i], -1, st);
        }
        ll ans = -1;
        for (int i = 0; i < m - 1; i++) {
            for (int j = i + 1; j < m; j++) {
                ans = max(ans, dist[i] + dist[j] + min((pr[j] - pr[i] + sum) % sum, sum - (pr[j] - pr[i] + sum) % sum));
            }
        }
        ans = max(ans, find_tree_diameter(-1, -1));
        cout << ans << '\n';
    }
    else {
        cout << find_tree_diameter(-1, -1) << '\n';
    }
}

vector<ll> find_cycle() {
    vector<ll> ans;
    ll b = 0;
    stack<ll> st;
    vector<bool> used(n);
    vector<ll> par(n);
    st.push(b);
    par[b] = -1;
    while (!st.empty()) {
        ll x = st.top();
        st.pop();
        if (used[x]) {
            continue;
        }
        used[x] = 1;
        for (auto i : G[x]) {
//            cout << x << ' ' << i.first << '\n';
            if (!used[i.first]) {
                par[i.first] = x;
                st.push(i.first);
            }
            else if (i.first != par[x]) {
                par[i.first] = x;
                ans.push_back(i.first);
                ll y = i.first;
                while (par[y] != i.first) {
//                    cout << '\t' << y << ' ' << par[y] << '\n';
                    ans.push_back(par[y]);
                    y = par[y];
                }
                return ans;
            }
        }
    }
}

ll dfs(ll x, ll par, set<ll> &st) {
    ll ans = 0;
    for (auto i : G[x]) {
        if (i.first != par && !st.count(i.first)) {
            ans = max(ans, dfs(i.first, x, st) + 1);
        }
    }
    return ans;
}

vector<ll> dists(ll d) {
    vector<ll> dist0(n, INF);
    vector<bool> used0(n);
    dist0[d] = 0;
    priority_queue< pair<ll, ll> > pq;
    pq.push({0, d});
    while (!pq.empty()) {
        auto p = pq.top();
        pq.pop();
        ll x = p.second;
        if (used0[x]) {
            continue;
        }
        used0[x] = 1;
        for (auto i : G[x]) {
            if (!used0[i.first]) {
                dist0[i.first] = min(dist0[i.first], dist0[x] + i.second);
                pq.push({-dist0[x] - i.second, i.first});
            }
        }
    }
    return dist0;
}

ll find_tree_diameter(ll fx, ll fy) {
//    cout << fx << ' ' << fy << '\n';
    ll d = 0;
    vector<ll> dist0 = dists(d);
    ll f = 0;
    for (int i = 1; i < n; i++) {
        if (dist0[i] >= dist0[f]) {
            f = i;
        }
    }
    vector<ll> distf = dists(f);
    ll e = 0;
    for (int i = 1; i < n; i++) {
        if (distf[i] >= distf[e]) {
            e = i;
        }
    }
//    for (int i : dist0) {
//        cout << i << ' ';
//    }
//    cout << '\n';
//    for (int i : distf) {
//        cout << i << ' ';
//    }
//    cout << '\n';
//    for (int i : distf1) {
//        cout << i << ' ';
//    }
//    cout << '\n';
//    cout << f << ' ' << e << ' ' << distf[e] << ' ' << distf1[e] << '\n';
    return distf[e];
}
