#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e16;

vector<long long> dijkstra(int start, const vector<vector<pair<int, int>>>& g) {
    int n = g.size();
    vector<long long> d(n, INF);
    d[start] = 0;
    set<pair<long long, int>> s;
    s.insert({0, start});
    while (!s.empty()) {
        int i = s.begin()->second;
        s.erase(s.begin());
        for (auto [j, w] : g[i]) {
            if (d[i] + w < d[j]) {
                s.erase({d[j], j});
                d[j] = d[i] + w;
                s.insert({d[j], j});
            }
        }
    }
    return d;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, tt;
    cin >> n >> tt;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    if (tt == 0 || tt == 2) {
        long long res = 0;
        for (int i = 0; i < n; ++i) {
            auto d = dijkstra(i, g);
            res = max(res, *max_element(d.begin(), d.end()));
        }
        cout << res << '\n';
    }
    return 0;
}
