#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e16;

vector<long long> dijkstra(int start, const vector<vector<pair<int, int>>>& g) {
    int n = g.size();
    vector<long long> d(n, INF);
    d[start] = 0;
    set<pair<long long, int>> s;
    s.insert({0, start});
    while (!s.empty()) {
        int i = s.begin()->second;
        s.erase(s.begin());
        for (auto [j, w] : g[i]) {
            if (d[i] + w < d[j]) {
                s.erase({d[j], j});
                d[j] = d[i] + w;
                s.insert({d[j], j});
            }
        }
    }
    return d;
}

void dfs(int i, const vector<vector<pair<int, int>>>& g, int p, vector<long long>& v) {
    if (i == 0) {
        return;
    }
    for (auto [j, w] : g[i]) {
        if (j != p) {
            v.push_back(w);
//            cout << j + 1 << ' ' << w << '\n';
            dfs(j, g, i, v);
        }
    }
}

int getPref(const vector<long long>& pref, int i) {
    return i >= 0 ? pref[i] : 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, tt;
    cin >> n >> tt;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }
    if (tt == 0 || tt == 2) {
        long long res = 0;
        for (int i = 0; i < n; ++i) {
            auto d = dijkstra(i, g);
            res = max(res, *max_element(d.begin(), d.end()));
        }
        cout << res << '\n';
        return 0;
    } else if (tt == 1) {
        vector<long long> v;
        v.push_back(g[0][0].second);
        dfs(g[0][0].first, g, 0, v);
        long long sum = 0;
        for (auto i : v) {
//            cout << i << ' ';
            sum += i;
        }
        int res = 0;
        vector<long long> pref(v.size());
        pref[0] = v[0];
        for (int i = 1; i < v.size(); ++i) {
            pref[i] = pref[i - 1] + v[i];
        }
        for (int i = 0; i < v.size(); ++i) {
            int left = 0, right = v.size();
            while (left + 1 < right) {
                int mid = (left + right) / 2;
                if (2 * (getPref(pref, i + mid - 1) - getPref(pref, i - 1)) <= sum) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            res = max(res, getPref(pref, i + left - 1) - getPref(pref, i - 1));
        }
        cout << res << '\n';
        return 0;
    }
    return 0;
}
