#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e16;

vector<long long> dijkstra(int start, const vector<vector<pair<int, int>>>& g) {
    int n = g.size();
    vector<long long> d(n, INF);
    d[start] = 0;
    set<pair<long long, int>> s;
    s.insert({0, start});
    while (!s.empty()) {
        int i = s.begin()->second;
        s.erase(s.begin());
        for (auto [j, w] : g[i]) {
            if (d[i] + w < d[j]) {
                s.erase({d[j], j});
                d[j] = d[i] + w;
                s.insert({d[j], j});
            }
        }
    }
    return d;
}

void dfs(int i, const vector<vector<pair<int, int>>>& g, int p, vector<long long>& v) {
    if (i == 0) {
        return;
    }
    for (auto [j, w] : g[i]) {
        if (j != p) {
            v.push_back(w);
            dfs(j, g, i, v);
        }
    }
}

long long getPref(const vector<long long>& pref, int i) {
    return i >= 0 ? pref[i] : 0;
}

const int N = 2e5;
bool hasCycle = false;
vector<int> cycle;
vector<int> cycleSorted;

void dfs2(int v, const vector<vector<pair<int, int>>>& g, vector<bool>& isVisited, vector<int>& c, int p = -1) {
    isVisited[v] = true;
    c.push_back(v);
    for (auto [u, w] : g[v]) {
        if (hasCycle) {
            return;
        }
        if (!isVisited[u]) {
            dfs2(u, g, isVisited, c, v);
        } else if (u != p) {
            cycle = c;
            reverse(cycle.begin(), cycle.end());
            while (cycle.back() != u){
                cycle.pop_back();
            }
            hasCycle = true;
        }
    }
    c.pop_back();
}

long long res = 0;

long long treePref[N];

long long treeCount(int i, const vector<vector<pair<int, int>>>& g, int p = -1) {
    multiset<long long> s;
    for (auto [j, w] : g[i]) {
        if (!binary_search(cycleSorted.begin(), cycleSorted.end(), j) && j != p) {
            s.insert(treeCount(j, g, i) + w);
        }
    }
    if (s.empty()) {
        return 0;
    }
    long long ret = *s.rbegin();
    if (s.size() >= 2) {
        auto it = s.end();
        --it;
        long long a = *it;
        --it;
        long long b = *it;
        res = max(res, a + b);
    }
    return ret;
}

map<pair<int, int>, int> mp;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, tt;
    cin >> n >> tt;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
        mp[{u, v}] = w;
        mp[{v, u}] = w;
    }
    if (tt == 2) {
        res = 0;
        for (int i = 0; i < n; ++i) {
            auto d = dijkstra(i, g);
            res = max(res, *max_element(d.begin(), d.end()));
        }
        cout << res << '\n';
        return 0;
    } else if (tt == 1) {
        vector<long long> v;
        v.push_back(g[0][0].second);
        dfs(g[0][0].first, g, 0, v);
        long long sum = 0;
        for (auto i : v) {
            sum += i;
        }
        vector<long long> pref(v.size());
        pref[0] = v[0];
        for (int i = 1; i < v.size(); ++i) {
            pref[i] = pref[i - 1] + v[i];
        }
        for (int i = 0; i < v.size(); ++i) {
            int left = 0, right = v.size();
            while (left + 1 < right) {
                int mid = (left + right) / 2;
                if (2 * (getPref(pref, i + mid - 1) - getPref(pref, i - 1)) <= sum) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            res = max(res, getPref(pref, i + left - 1) - getPref(pref, i - 1));
        }
        for (int i = 0; i < v.size(); ++i) {
            if (2 * pref[i] > sum) {
                break;
            }
            int left = i + 1, right = n;
            while (left + 1 < right) {
                int mid = (left + right) / 2;
                if (2 * (pref[i] + pref[n - 1] - pref[mid - 1]) <= sum) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            res = max(res, pref[i] + pref[n - 1] - pref[right - 1]);
        }
        cout << res << '\n';
        return 0;
    } else if (tt == 3 || tt == 0) {
        vector<bool> isVisited(n, false);
        vector<int> c;
        dfs2(0, g, isVisited, c);
        cycleSorted = cycle;
        sort(cycleSorted.begin(), cycleSorted.end());

        for (auto i : cycle) {
            treePref[i] = treeCount(i, g);
        }
        long long sum = 0;
        vector<long long> pref(cycle.size());
        for (int i = 0; i < cycle.size(); ++i) {
            sum += mp[{cycle[i], cycle[(i + 1) % cycle.size()]}];
            pref[i] = sum;
        }
        for (int i = 0; i < pref.size(); ++i) {
            int left = 0, right = pref.size();
            while (left + 1 < right) {
                int mid = (left + right) / 2;
                if (2 * (getPref(pref, i + mid - 1) - getPref(pref, i - 1)) <= sum) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            for (int len = i; len <= left; ++len) {
                res = max(res, treePref[i] + getPref(pref, i + len - 1) - getPref(pref, i - 1) + treePref[i + left]);
            }
//            res = max(res, getPref(pref, i + left - 1) - getPref(pref, i - 1));
        }

        for (int i = 0; i < pref.size(); ++i) {
            if (2 * pref[i] > sum) {
                break;
            }
            int left = i + 1, right = n;
            while (left + 1 < right) {
                int mid = (left + right) / 2;
                if (2 * (pref[i] + pref[n - 1] - pref[mid - 1]) <= sum) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            res = max(res, pref[i] + pref[n - 1] - pref[right - 1] + treePref[i] + treePref[right + 1]);
        }


//        for (int i = 0; i < 2 * cycle.size(); ++i) {
//            long long curr = 0;
//            for (int j = i + 1; j < 2 * cycle.size(); ++j) {
//                curr += mp[{cycle[(j - 1) % cycle.size()], cycle[j % cycle.size()]}];
//                if (2 * curr > sum) {
//                    break;
//                }
//                res = max(res, curr + treePref[cycle[i % cycle.size()]] + treePref[cycle[j % cycle.size()]]);
//            }
//        }

        cout << res << '\n';
        return 0;
    }
    return 0;
}
