import java.util.*;
class MyGraph {
    int distances[];
    Set<Integer> visit;
    PriorityQueue<Node> my_queue;
    int V;
    List<List<Node> > adj_list;
    public MyGraph(int V) {
        distances = new int[V];
        this.V = V;
        visit = new HashSet<Integer>();
        my_queue = new PriorityQueue<Node>(V, new Node());
    }

    public void findPath(List<List<Node> > adj_list, int src_vertex)
    {
        this.adj_list = adj_list;
        for (int i = 0; i < V; i++)
            distances[i] = Integer.MAX_VALUE;

        my_queue.add(new Node(src_vertex, 0));
        distances[src_vertex] = 0;
        while (visit.size() != V && my_queue.size() > 0) {
            int u = my_queue.remove().node;
            visit.add(u);
            nearGraph(u);
        }
        for (int i = 0; i < distances.length; i++) {
            if (distances[i] == Integer.MAX_VALUE) distances[i] = -1;
        }
    }

    private void nearGraph(int u)   {
        int edgeDistance = -1;
        int newDistance = -1;

        for (int i = 0; i < adj_list.get(u).size(); i++) {
            Node v = adj_list.get(u).get(i);

            if (!visit.contains(v.node)) {
                edgeDistance = v.val;
                newDistance = distances[u] + edgeDistance;

                if (newDistance < distances[v.node])
                    distances[v.node] = newDistance;
                my_queue.add(new Node(v.node, distances[v.node]));
            }
        }
    }
}

class Main {
    public static void main(String arg[])   {

        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int g = sc.nextInt();

        List<List<Node> > adj_list = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            List<Node> item = new ArrayList<>();
            adj_list.add(item);
        }

        for (int i = 0; i < n; i++) {
            int source = sc.nextInt();
            int node = sc.nextInt();
            int val = sc.nextInt();
            addMyNode(adj_list, source, node, val);
            addMyNode(adj_list, node, source, val);
        }

        int max = 0;
        for (int i = 0; i < n; i++) {
            MyGraph dpq = new MyGraph(n);
            dpq.findPath(adj_list, i);
            for (int k = 0; k < dpq.distances.length; k++) {
                int dist = dpq.distances[k];
                if (max < dist) max = dist;
            }
        }
        System.out.println(max);
    }

    public static void addMyNode(List<List<Node>> arr, int source, int node, int val) {
        arr.get(source - 1).add(new Node(node - 1, val));
    }
}

// Node class  
class Node implements Comparator<Node> {
    public int node;
    public int val;
    public Node() { }

    public Node(int node, int val) {
        this.node = node;
        this.val = val;
    }

    public int compare(Node node1, Node node2)
    {
        if (node1.val < node2.val) return -1;
        if (node1.val > node2.val) return 1;
        return 0;
    }
}