import java.util.Scanner;
import java.util.Vector;

public class Main
{
    static int max_length = Integer.MIN_VALUE;
    static void findPath(Vector<Vector<Node>> arr, int src,
                    int length_before, boolean[] visit) {

        visit[src] = true;
        int current_len = 0;
        Node near;

        for(int i = 0; i < arr.get(src).size(); i++)
        {
            near = arr.get(src).get(i);
            if (!visit[near.x])
            {
                current_len = length_before + near.y;
                findPath(arr, near.x, current_len, visit);
            }
            if (max_length < current_len) max_length = current_len;
            current_len = 0;
        }
    }

    static int maxDistance(Vector<Vector<Node>> arr, int n)
    {
        for (int i = 1; i <= n; i++) {
            boolean[] visit = new boolean[n + 1];
            findPath(arr, i, 0, visit);
        }
        return max_length;
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int g = sc.nextInt();

        Vector<Vector<Node>> arr = new Vector<>();
        for(int i = 0; i < n + 1; i++)
        {
            arr.add(new Vector<>());
        }

        for (int i = 0; i < n; i++) {
            int start = sc.nextInt();
            int end = sc.nextInt();
            int val = sc.nextInt();
            addMyNode(arr, start, end, val);
        }

        System.out.println(maxDistance(arr, n));
    }

    public static void addMyNode(Vector<Vector<Node>> arr, int start, int end, int val) {
        arr.get(start).add(new Node(end, val));
        arr.get(end).add(new Node(start, val));
    }

    static class Node {
        public int x, y;
        public Node(int f, int s)
        {
            x = f;
            y = s;
        }
    }
}