import java.util.Scanner;

class Main {
    final static int INF = (int)Math.pow(10, 9) + 1;
    static void floyd(int graph[][], int n) {
        int arr[][] = new int[n][n];
        int i, j, k;

        for (i = 0; i < n; i++)
            for (j = 0; j < n; j++)
                arr[i][j] = graph[i][j];

        for (k = 0; k < n; k++) {
            for (i = 0; i < n; i++) {
                for (j = 0; j < n; j++) {
                    if (arr[i][k] + arr[k][j] < arr[i][j])
                        arr[i][j] = arr[i][k] + arr[k][j];
                }
            }
        }

        int max = 0;
        for (int l = 0; l < n; l++) {
            for (int m = 0; m < n; m++) {
                if (max < arr[l][m]) {
                    max = arr[l][m];
                }
            }
        }
        System.out.println(max);
    }


    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int g = sc.nextInt();

        int[][] graph = new int[n][n];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                graph[i][j] = INF;
                if (i == j) graph[i][j] = 0;
            }
        }

        for (int i = 0; i < n; i++) {
            int source = sc.nextInt();
            int node = sc.nextInt();
            int val = sc.nextInt();
            graph[source-1][node-1] = val;
            graph[node-1][source-1] = val;
        }

        floyd(graph, n);
    }
}