#include <cstdio>
#include <deque>
#include <utility>
#include <vector>

const int N = 200005;
int n, G, next[N], from[N];
bool u[N], in[N];
std::vector<std::pair<int, int> > g[N];
long long dst[N], sum[N << 1], w[N << 1];

std::vector<int> cyc;
int dfs0(int v, int pr = -1) {
	if (u[v]) {
		in[v] = 1;
		cyc.push_back(v);
		return 1;
	}
	u[v] = 1;
	for (int i = 0; i < (int)g[v].size(); ++i) if (g[v][i].first != pr) {
		int k = dfs0(g[v][i].first, v);
		if (k) {
			if (k == 1 && cyc.front() == v) k = 2;
			if (k == 1) {
				in[v] = 1;
				cyc.push_back(v);
			}
			return k;
		}
	}
	return 0;
}

std::pair<long long, int> far;
void find_far(int v, long long dist = 0, int pr = -1) {
	far = std::max(far, std::make_pair(dist, v));
	for (int i = 0; i < (int)g[v].size(); ++i) if (g[v][i].first != pr && !in[g[v][i].first]) find_far(g[v][i].first, dist + g[v][i].second, v);
}

inline int z(int x) {
	if (x >= cyc.size()) x -= cyc.size();
	return x;
}

int main() {
	scanf("%d%d", &n, &G);
	for (int i = 0; i < n; ++i) {
		int a, b, c;
		scanf("%d%d%d", &a, &b, &c);
		g[a - 1].push_back(std::make_pair(b - 1, c));
		g[b - 1].push_back(std::make_pair(a - 1, c));
	}
	dfs0(0);
	std::pair<long long, std::pair<int, int> > ans;
	long long len = 0;
	for (int i = 0; i < (int)cyc.size(); ++i) {
		in[cyc[i]] = 0;
		far.first = -1;
		find_far(cyc[i]);
		from[i] = far.second;
		dst[i] = far.first;
		far.first = -1;
		find_far(from[i]);
		ans = std::max(ans, std::make_pair(far.first, std::make_pair(from[i], far.second)));
		for (int j = 0; j < (int)g[cyc[i]].size(); ++j) if (g[cyc[i]][j].first == cyc[i == (int)cyc.size() - 1 ? 0 : i + 1]) next[i] = g[cyc[i]][j].second;
		len += next[i];
		in[cyc[i]] = 1;
	}
	std::deque<int> dq;
	for (int i = 0, j = 0; i < (int)cyc.size() << 1; ++i) {
		sum[i + 1] = sum[i] + next[z(i)];
		w[i] = dst[z(i)] - sum[i];
		while (!dq.empty() && w[dq.back()] <= w[i]) dq.pop_back();
		dq.push_back(i);
		while (sum[i] - sum[j] << 1 > len) {
			if (dq.front() == j) dq.pop_front();
			++j;
		}
		if (!dq.empty()) ans = std::max(ans, std::make_pair(sum[i] + dst[z(i)] + w[dq.front()], std::make_pair(from[z(i)], from[z(dq.front())])));
	}
	printf("%lld\n", ans.first);
	return 0;
}
