#include <cstdio>
#include <vector>
#include <cstring>

const int N = 50000;
const int L = 20;
int n, G, in[N], out[N], a[N], q;
std::vector<int> g[N];

struct item {
	int a[L];
	item() {
		memset(a, 0, L << 2);
	}
	void add(int x) {
		for (int i = L - 1; i >= 0; --i) if (x >> i & 1) {
			if (a[i]) x ^= a[i];
			else {
				a[i] = x;
				return;
			}
		}
	}
	item(int x) {
		memset(a, 0, L << 2);
		add(x);
	}
	item operator+(item arg) {
		item res = *this;
		for (int i = 0; i < L; ++i) if (arg.a[i]) res.add(arg.a[i]);
		return res;
	}
	int ask(int k) {
		int amt = 0;
		for (int i = 0; i < L; ++i) amt += (bool)a[i];
		if (k >= 1 << amt) return -1;
		int res = 0;
		for (int i = L - 1; i >= 0; --i) if (a[i]) {
			--amt;
			if ((k >> amt ^ res >> i) & 1) res ^= a[i];
		}
		return res;
	}
} t[N << 1];

void dfs(int v, int pr = -1) {
	static int dt = 0;
	t[n + dt] = item(a[v]);
	in[v] = dt++;
	for (int i = 0; i < (int)g[v].size(); ++i) if (g[v][i] != pr) dfs(g[v][i], v);
	out[v] = dt;
}

void update(int i, int x) {
	for (i += n, t[i] = item(x); i > 1; i >>= 1) t[i >> 1] = t[i] + t[i ^ 1];
}

item query(int l, int r) {
	item res;
	for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
		if (l & 1) res = res + t[l++];
		if (r & 1) res = res + t[--r];
	}
	return res;
}

int main() {
	scanf("%d%d", &n, &G);
	for (int i = 1; i < n; ++i) {
		int a, b;
		scanf("%d%d", &a, &b);
		g[a - 1].push_back(b - 1);
		g[b - 1].push_back(a - 1);
	}
	for (int i = 0; i < n; ++i) scanf("%d", a + i);
	dfs(0);
	for (int i = n - 1; i > 0; --i) t[i] = t[i << 1] + t[i << 1 | 1];
	scanf("%d", &q);
	while (q--) {
		int type, x, y;
		scanf("%d%d%d", &type, &x, &y);
		--x;
		if (type == 1) update(in[x], y);
		else printf("%d\n", query(in[x], out[x]).ask(y - 1));
	}
	return 0;
}
